unit timememo1;
{
Copyright (C) 2001 Patrick Chevalley

http://www.astrosurf.org/astropc
pch@freesurf.ch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$IFNDEF MSWINDOWS}
  {$IFDEF WIN32}
    {$DEFINE MSWINDOWS}
  {$ENDIF}
{$ENDIF}

interface

uses
{$IFDEF LINUX}
  QTypes, QForms, QControls, QExtCtrls, QStdCtrls, QGraphics,
{$ENDIF}
{$IFDEF MSWINDOWS}
  Windows, Forms, Controls, StdCtrls, ExtCtrls, Graphics,
{$ENDIF}
  SysUtils, Inifiles, Classes,
  SNTPsend ;


type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    Edit5: TEdit;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Panel4: TPanel;
    Label7: TLabel;
    Panel1: TPanel;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Button4: TButton;
    Label9: TLabel;
    Label10: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    CheckBox2: TCheckBox;
    Panel5: TPanel;
    Memo1: TMemo;
    Image1: TImage;
{$IFDEF MSWINDOWS}
    Timer2: TTimer;
{$ENDIF}
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Dclarations prives }
    procedure SynchroTime;
    procedure CheckTime(canset : boolean);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

const datefmtiso = 'yyyy"-"mm"-"dd" "hh":"nn":"ss"."zzz';
      sep = ' | ';
{$IFDEF LINUX}
      InitFile = './timememo.ini';
{$ENDIF}
{$IFDEF MSWINDOWS}
      InitFile = '.\timememo.ini';
{$ENDIF}


var   sntp:TSntpSend;
      LastSet : Tdatetime;
      RefRate   : integer;
      SyncEvery : integer;
      MinSync   : double;
      MaxSync   : double;
      startimmed:boolean;
      starthide:boolean;

{$IFDEF LINUX}
   {$R *.xfm}
{$ENDIF}
{$IFDEF MSWINDOWS}
   {$R *.dfm}
{$ENDIF}

Procedure Writememo(lin : string);
var f : textfile;
begin
Assignfile(f,form1.edit5.text);
if fileexists(form1.edit5.text) then append(f) else rewrite(f);
writeln(f,lin);
closefile(f);
end;

Procedure Cleanmemo;
var i : integer;
begin
with Form1.memo1 do begin
  if (lines.count mod 100)=0 then begin
     lines.beginupdate;
     for i:=1 to 50 do lines.Delete(0);
     lines.endupdate;
  end;
end;
end;

procedure TForm1.CheckTime(canset : boolean);
var
  lin : string;
begin
  lin:='';
  try
    if sntp.GetNTPhp
      then begin
        lin:=FormatDatetime(datefmtiso,sntp.GetUTTime)+sep+FormatDatetime(datefmtiso,sntp.NTPTime)+sep+
             format('%8.2f',[sntp.NTPOffset])+sep+format('%5.2f',[sntp.NTPDelay])+sep;
        memo1.lines.add(lin);
        if CheckBox1.checked then writememo(lin);
        if canset and checkbox2.checked and (abs(sntp.NTPOffset)>MinSync) and (((sntp.GetUTTime-LastSet)*86400)>SyncEvery) then begin
           SynchroTime;
           LastSet:=sntp.GetUTTime;
        end;
      end
      else begin
        lin:=FormatDatetime(datefmtiso,sntp.GetUTTime)+' Server or connection error!';
        memo1.lines.add(lin);
        if CheckBox1.checked then writememo(lin);
      end;
  finally
    Cleanmemo;
  end;
end;

procedure TForm1.SynchroTime;
var
  ok : boolean;
  lin : string;
begin
  lin:='';
  try
    if sntp.SynchroNTP(ok)
      then begin
        lin:=FormatDatetime(datefmtiso,sntp.GetUTTime)+sep+FormatDatetime(datefmtiso,sntp.NTPTime)+sep+
             format('%8.2f',[sntp.NTPOffset])+sep+format('%5.2f',[sntp.NTPDelay]);
        if ok then lin:=lin+sep+'OK!'
              else lin:=lin+sep+'Failed!';
        memo1.lines.add(lin);
      end
      else begin
        lin:=FormatDatetime(datefmtiso,sntp.GetUTTime)+' Server or connection error!';
        memo1.lines.add(lin);
      end;
  finally
    if CheckBox1.checked then writememo(lin);
  end;
end;

function EditToInt(edit : Tedit; min,max : integer; var i : integer): boolean;
var code : Integer;
begin
result:=false;
val(edit.text,i,code);
if (code=0)and(i>=min)and(i<=max) then result:=true
   else begin
     beep;
     edit.hint:=inttostr(min)+'..'+inttostr(max);
     edit.showhint:=true;
     edit.SetFocus;
     edit.SelectAll;
end;
end;

function EditToFloat(edit : Tedit; min,max : integer; var x : double): boolean;
var code : Integer;
begin
result:=false;
val(edit.text,x,code);
if (code=0)and(x>=min)and(x<=max) then result:=true
   else begin
     beep;
     edit.hint:=floattostr(min)+'..'+floattostr(max);
     edit.showhint:=true;
     edit.SetFocus;
     edit.SelectAll;
end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var lin : string;
begin
if timer1.enabled then begin
   timer1.enabled:=false;
   button1.caption:='Start';
   panel1.color:=clred;
   edit1.enabled:=true;
   edit2.enabled:=true;
   edit3.enabled:=true;
   edit4.enabled:=true;
   combobox1.enabled:=true;
   checkbox2.enabled:=true;
   edit5.enabled:=true;
   lin:=(FormatDatetime(datefmtiso,sntp.GetUTTime)+' Stop');
   memo1.lines.add(lin);
   if CheckBox1.checked then writememo(lin);
end else begin
   sntp.SntpHost:=combobox1.Text;
   sntp.MaxSynchro:=Maxsync;
   timer1.interval:=Refrate*1000;
   timer1.enabled:=true;
   button1.caption:='Stop';
   panel1.color:=clLime;
   edit1.enabled:=false;
   edit2.enabled:=false;
   edit3.enabled:=false;
   edit4.enabled:=false;
   combobox1.enabled:=false;
   checkbox2.enabled:=false;
   edit5.enabled:=false;
   if CheckBox1.checked then begin
      writememo(' ');
      lin:='NTP Server : '+sntp.SntpHost;
      writememo(lin);
      lin:=label8.caption;
      writememo(lin);
      lin:='----------------------- | ----------------------- | -------- | ----- | -----';
      writememo(lin);
   end;
   checktime(true);
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
checktime(true);
end;

procedure TForm1.FormCreate(Sender: TObject);
var ini : Tinifile;
    i : integer;
begin
sntp:=TSntpSend.Create;
LastSet:=0;
if fileexists('timeserver.lst') then begin
     combobox1.Items.clear;
     combobox1.Items.LoadFromFile('timeserver.lst');
     combobox1.ItemIndex:=0;
end;
decimalseparator:='.';
ini:= TInifile.Create(InitFile);
RefRate:=ini.readInteger('Default','RefRate',15);
SyncEvery:=ini.readInteger('Default','SyncEvery',60);
MinSync:=ini.readFloat('Default','MinSync',0.1);
MaxSync:=ini.readFloat('Default','MaxSync',3600);
combobox1.text:=ini.readstring('Default','NTPhost',combobox1.text);
edit5.text:=ini.readstring('Default','FileName','timememo.txt');
Checkbox1.Checked:=ini.readBool('Default','RecFile',true);
Checkbox2.Checked:=ini.readBool('Default','AutoSync',true);
ini.free;
edit1.text:=inttostr(RefRate);
edit3.text:=inttostr(SyncEvery);
edit2.text:=floattostr(MinSync);
edit4.text:=floattostr(MaxSync);
CheckBox2Click(sender);
startimmed:=false;
starthide:=false;
for i:=1 to paramcount do begin
  if paramstr(i)='-s' then startimmed:=true;
  if paramstr(i)='-d' then begin starthide:=true; startimmed:=true; end;
end;
if startimmed then Button1Click(Sender);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
sntp.SntpHost:=combobox1.Text;
if CheckBox1.checked then writememo('NTP Server : '+sntp.SntpHost);
SynchroTime;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
sntp.SntpHost:=combobox1.Text;
if CheckBox1.checked then writememo('NTP Server : '+sntp.SntpHost);
checktime(false);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
edittoint(edit1,0,86400,RefRate);
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
edittofloat(edit2,0,100,Minsync);
end;

procedure TForm1.Edit3Exit(Sender: TObject);
begin
edittoint(edit3,0,86400,Syncevery);
end;

procedure TForm1.Edit4Exit(Sender: TObject);
begin
edittofloat(edit4,0,86400,Maxsync);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
var active : boolean;
begin
if checkbox2.checked then
    active:=true
else
    active:=false;
edit2.enabled:=active;
edit3.enabled:=active;
edit4.enabled:=active;
label3.enabled:=active;
label4.enabled:=active;
label5.enabled:=active;
label6.enabled:=active;
label9.enabled:=active;
label10.enabled:=active;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var ini : Tinifile;
begin
ini:= TInifile.Create(InitFile);
ini.writeInteger('Default','RefRate',RefRate);
ini.writeInteger('Default','SyncEvery',SyncEvery);
ini.writeFloat('Default','MinSync',MinSync);
ini.writeFloat('Default','MaxSync',MaxSync);
ini.writestring('Default','NTPhost',combobox1.text);
ini.writestring('Default','FileName',edit5.text);
ini.writeBool('Default','RecFile',Checkbox1.Checked);
ini.writeBool('Default','AutoSync',Checkbox2.Checked);
ini.UpdateFile;
ini.free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
if starthide then form1.hide;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (key=4144)or(key=112) then begin
   Image1.Picture.Bitmap.LoadFromResourceName(Hinstance,'OSB_TITLEIMAGE');
   memo1.Visible:=false;
   form1.Refresh;
   sleep(3000);
   memo1.Visible:=true;
end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
{$IFDEF MSWINDOWS}
timer2.enabled:=true;
{$ENDIF}
end;


{$IFDEF MSWINDOWS}
procedure TForm1.Timer2Timer(Sender: TObject);
var key : word;
begin
 timer2.enabled:=false;
 key:=4144;
 FormKeyDown(nil,key,[]);
end;
{$ENDIF}

end.
